<?php
/**
* @name MOOJ Proforms 
* @version 1.0
* @package proforms
* @copyright Copyright (C) 2008-2010 Mad4Media. All rights reserved.
* @author Dipl. Inf.(FH) Fahrettin Kutyol
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Please note that some Javascript files are not under GNU/GPL License.
* These files are under the mad4media license
* They may edited and used infinitely but may not repuplished or redistributed.  
* For more information read the header notice of the js files.
**/
	
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );
 
define('MSEF_CAT',1);
define('MSEF_FORM',2);

class MSEF extends JObject{
	
	var $formId = null;
	var $catId = null;
	var $title = null;
	var $alias = null;
	var $sefUrl = null;

	function __construct($title=null,$alias=null,$formId=null,$catId=null){
		$this->title = $title;
		$this->alias = $alias;
		$this->formId =$formId;
		$this->catId = $catId;
		$this->createSEF();
	}
	
	function createSEF(){
		if(! $this->formId && ! $this->catId ) return null;	
		$url = ($this->alias)? $this->alias: $this->title;
		if(!$this->formId || $this->catId <0){
			$this->sefUrl = $this->check($this->get($url));
		}else{
			$db = & JFactory::getDBO();
			$query = $db->setQuery("SELECT `url` FROM #__m4j_sef WHERE `jid` = '0' AND `cid`= '".$this->catId."'");
			$cat = $db->loadObjectList();
			$this->sefUrl = $cat[0]->url."/".$this->check($this->get($url));
		}	
	}
	
	function insert(){
		$db = & JFactory::getDBO();
		$query = "INSERT INTO #__m4j_sef"
						. "\n ( `jid`, `cid`, `url` )"
						. "\n VALUES"
						. "\n ( '".(int) $this->formId."', '".$this->catId. "', '".$this->sefUrl."' )";
		$db->setQuery($query);
		$db->query();
	}
	
	function update(){
		$db = & JFactory::getDBO();
		if($this->formId){
			$query = $db->setQuery("SELECT * FROM #__m4j_sef WHERE `jid`= '".$this->formId."'");
			if(! $db->loadObject($query)){
				$this->insert();
			}else{
				$query = "UPDATE #__m4j_sef "
						. "\n SET"
						. "\n `cid` = '".$this->catId."', "
						. "\n `url` = '".$this->sefUrl."' "
						. "\n WHERE jid = '". $this->formId."' ";
				$db->setQuery($query);
				$db->query();
			}
		}else if(!$this->formId && $this->catId){
			$query = $db->setQuery("SELECT * FROM #__m4j_sef WHERE `jid` = '0' AND `cid`= '".(int)$this->catId."'");
			if(! $db->loadObject($query)){
				$this->insert();
			}else{
				$query = "UPDATE #__m4j_sef "
						. "\n SET"
						. "\n `jid` = '0', "
						. "\n `url` = '".$this->sefUrl."' "
						. "\n WHERE `jid` = '0' AND cid = '". $this->catId."' ";
				$db->setQuery($query);
				$db->query();
			}	
		}
	}
	
	function replace($string=null){
		$toReplace = "á|a, Á|A, ã|a, Ã|A, â|a, Â|A, à|a, À|A, é|e, É, ê|e, Ê, í|i, Í|I, ó|o, ".
					 "Ó|O, õ|o, Õ|O, ô|o, Ô|O, ú|u, Ú|U, ç|c, Ç|C, Ã|A, ã|a, è|e, ì|i, ò|o, ".
					 "ö|oe, ü|ue, ä|ae, ß|ss, Ö|Oe, Ä|Ae, Ü|Ue, ";

		
		$change_chars="Ã?|A, Ã‚|A, Ä‚|A, Ã„|Ae, Ä†|C, Ã‡|C, ÄŒ|C, ÄŽ|D, Ä?|D, Ã‰|E, Ä?|E, Ã‹|E, Äš|E, ".
					  "Ã|I, ÃŽ|I, Ä¹|L, Å?|N, Å‡|N, Ã“|O, Ã”|O, Å?|O, Ã–|Oe, Å”|R, Å?|R, Å |S, Åš|O, Å¤|T, ".
					  "Å®|U, Ãš|U, Å°|U, Ãœ|Ue, Ã|Y, Å½|Z, Å¹|Z, Ã¡|a, Ã¢|a, Ä?|a, Ã¤|ae, Ä‡|c, Ã§|c, Ä|c, Ä|d, ".
					  "Ä‘|d, Ã©|e, Ä™|e, Ã«|e, Ä›|e, Ã­|i, Ã®|i, Äº|l, Å„|n, Å?|n, Ã³|o, Ã´|o, Å‘|o, Ã¶|oe, Å¡|s, Å›|s, ".
					  "Å™|r, Å•|r, Å¥|t, Å¯|u, Ãº|u, Å±|u, Ã¼|ue, Ã½|y, Å¾|z, Åº|z, Ë™|-, ÃŸ|ss, Ä„|A, Âµ|u, ß|ss, @|at, ".
					  "#|-, $|s, §|s, *|-, '|-, \"|-, +|-";
		
		$toReplace .= $change_chars;
		
		$firstSplit = explode(",",$toReplace);
		
		foreach ($firstSplit as $combination){
			$secondSplit = explode ("|",$combination);
			if(sizeof($secondSplit)== 2){
				$replace = trim($secondSplit[0]);
				$with = trim($secondSplit[1]);				
				$string = str_replace($replace,$with,$string);
			}
		}
		return $string;		
	}
	
	function toMinus($string=null){
		$toMinus = " |,|~|!|@|%|^|(|)|<|>|:|;|{|}|[|]|&|`|â€ž|â€¹|â€™|â€˜|â€œ|â€�|â€¢|â€º|Â«|Â´|Â»|Â°";
		$replace = explode("|",$toMinus);
		$string = str_replace($replace,"-",$string);
		$string = str_replace("--","-",$string);
		$string = str_replace("--","-",$string);
		$string = str_replace("--","-",$string);
		$string .='!!';
		$string = str_replace("-!!","",$string);
		$string = str_replace("!!","",$string);
		return $string;
	}
	
	function get($string=null){
		if(!$string) return null;
		$string = $this->toMinus($string);
		$string =  $this->replace($string);
		return strtolower($string);
	}
	
	function check($url=null){
		if(! $url) return null;
		$db = & JFactory::getDBO();
		$count = 2;
		$returnUrl = $url;
		$query = $db->setQuery("SELECT `url` FROM #__m4j_sef WHERE `url`= '".$url."'");
		while($db->loadResult($query)){
			$returnUrl = $url."-".$count++;
			$query = $db->setQuery("SELECT `url` FROM #__m4j_sef WHERE `url`= '".$returnUrl."'");
		}
		return $returnUrl;		
	}
	
	function delete($id=null,$type= null){
		if(!$type || !$id) return null;
		$db = & JFactory::getDBO();
		switch ($type){
			case MSEF_CAT:
				$query = "DELETE FROM #__m4j_sef WHERE `jid` = '0' AND `cid` = '".$id."'";	
				break;

			case MSEF_FORM:
				$query = "DELETE FROM #__m4j_sef WHERE `jid` = '".$id."'";
				break;
			
		}
		$db->setQuery($query);
		$db->query(); 	
	}
	
	
}
    
?>