DROP TABLE IF EXISTS `#__m4j_captcha`;
CREATE TABLE IF NOT EXISTS `#__m4j_captcha` (
  `date` timestamp NOT NULL,
  `user` varchar(64) NOT NULL,
  `captcha` varchar(64) NOT NULL,
  `dead` tinyint(4) DEFAULT '0',
  PRIMARY KEY (`user`)
);


DROP TABLE IF EXISTS `#__m4j_category`;
CREATE TABLE IF NOT EXISTS `#__m4j_category` (
  `cid` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT NULL,
  `alias` varchar(80) DEFAULT NULL,
  `active` tinyint(4) DEFAULT '1',
  `email` varchar(100) DEFAULT NULL,
  `introtext` text,
  `sort_order` int(11) DEFAULT NULL,
  `access` INT( 11 ) NOT NULL DEFAULT '0',
  PRIMARY KEY (`cid`)
);


DROP TABLE IF EXISTS `#__m4j_config`;
CREATE TABLE IF NOT EXISTS `#__m4j_config` (
  `key` varchar(64) NOT NULL,
  `value` text DEFAULT NULL,
  `type` varchar(64) NOT NULL,
  `namespace` varchar(64) DEFAULT NULL,
  PRIMARY KEY (`key`)
);


INSERT INTO `#__m4j_config` (`key`, `value`, `type`, `namespace`) VALUES
('M4J_EMAIL_ROOT', 'you@yourdomain.com', 'string', 'main'),
('M4J_MAIL_ISO', 'utf-8', 'string', 'main'),
('M4J_FROM_NAME', 'Your From Name', 'string', 'main'),
('M4J_FROM_EMAIL', 'from_mail@yourdomain.com', 'string', 'main'),
('M4J_CAPTCHA', 'RECAPTCHA', 'string', 'main'),
('M4J_RECAPTCHA', 'red', 'string', 'main'),
('M4J_HELP_ICON', '3', 'int', 'main'),
('M4J_MAX_OPTIONS', '19', 'int', 'main'),
('M4J_CAPTCHA_DURATION', '5', 'int', 'main'),
('M4J_HTML_MAIL', '1', 'int', 'main'),
('M4J_SHOW_LEGEND', '1', 'int', 'main'),
('M4J_SUBMISSION_TIME', '10000', 'int', 'main'),
('M4J_FORM_TITLE', '1', 'int', 'main'),
('M4J_SHOW_NO_CATEGORY', '1', 'int', 'main'),
('M4J_FORCE_CALENDAR', '0', 'int', 'main'),
('M4J_STORAGE_TD', '250', 'int', 'main'),
('M4J_WORKAREA', '940', 'int', 'main'),
('M4J_CLASS_HEADING', 'contentheading', 'string', 'css'),
('M4J_CLASS_LIST_HEADING', 'm4j_list_heading', 'string', 'css'),
('M4J_CLASS_LIST_INTRO', 'm4j_list_intro', 'string', 'css'),
('M4J_CLASS_LIST_WRAP', 'm4j_list_wrap', 'string', 'css'),
('M4J_CLASS_HEADER_TEXT', 'm4j_header_text', 'string', 'css'),
('M4J_CLASS_FORM_WRAP', 'm4j_form_wrap', 'string', 'css'),
('M4J_CLASS_FORM_TABLE', 'm4j_form_table', 'string', 'css'),
('M4J_CLASS_ERROR', 'm4j_error', 'string', 'css'),
('M4J_CLASS_SUBMIT_WRAP', 'm4j_submit_wrap', 'string', 'css'),
('M4J_CLASS_SUBMIT', 'm4j_submit', 'string', 'css'),
('M4J_CLASS_RESET', 'm4j_reset', 'string', 'css'),
('M4J_CLASS_REQUIRED', 'm4j_required', 'string', 'css'),
('M4J_SHOW_USER_INFO', '1', 'int', 'main'),
('M4J_FORCE_ADMIN_LANG', '', 'string', 'main'),
('M4J_USE_JS_VALIDATION', '1', 'int', 'main'),
('M4J_VERSION_NO', '1.0.5', 'string', 'main'),
('M4J_ERROR_COLOR', 'ff0000', 'string', 'main'),
('M4J_BUILD', '105', 'int', 'update'),
('M4J_SERVICE_KEY', 'Please enter your service key here', 'string', 'update'),
('M4J_UNIQUE_ID', NULL , 'string', 'update');


DROP TABLE IF EXISTS `#__m4j_formelements`;
CREATE TABLE IF NOT EXISTS `#__m4j_formelements` (
  `eid` int(11) NOT NULL AUTO_INCREMENT,
  `fid` int(11) NOT NULL,
  `required` tinyint(4) DEFAULT NULL,
  `active` tinyint(4) DEFAULT '1',
  `usermail` tinyint(4) DEFAULT '0',
  `align` tinyint(4) DEFAULT '0',
  `question` text NOT NULL,
  `form` int(11) NOT NULL,
  `parameters` text,
  `options` text,
  `help` text,
  `html` text,
  `slot` tinyint(4) NOT NULL DEFAULT '1',
  `sort_order` int(11) NOT NULL,
  `alias` VARCHAR( 128 ) NULL DEFAULT NULL,
  PRIMARY KEY (`eid`)
);

DROP TABLE IF EXISTS `#__m4j_forms`;
CREATE TABLE IF NOT EXISTS `#__m4j_forms` (
  `fid` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(64) NOT NULL,
  `description` text,
  `question_width` tinytext,
  `answer_width` tinytext,
  `use_help` tinyint(4) DEFAULT '1',
  `layout` varchar(64) NOT NULL DEFAULT 'layout01',
  `layout_data` text,
  `public` tinyint(4) DEFAULT '1',
  PRIMARY KEY (`fid`)
);

DROP TABLE IF EXISTS `#__m4j_jobs`;
CREATE TABLE IF NOT EXISTS `#__m4j_jobs` (
  `jid` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(64) NOT NULL,
  `alias` varchar(80) DEFAULT NULL,
  `hidden` text,
  `introtext` text,
  `maintext` text,
  `active` tinyint(4) DEFAULT NULL,
  `fid` text,
  `cid` int(11) DEFAULT '-1',
  `email` varchar(200) DEFAULT NULL,
  `subject` varchar(200) DEFAULT NULL,
  `text_confirm_only` tinyint(4) NOT NULL DEFAULT '1',
  `captcha` tinyint(4) DEFAULT '1',
  `sort_order` int(11) DEFAULT NULL,
  `public` tinyint(4) DEFAULT '1',
  `process` tinyint(4) DEFAULT '0',
  `confirmation` tinyint(4) NOT NULL DEFAULT '0',
  `aftersending` tinyint(4) NOT NULL DEFAULT '0',
  `redirect` varchar(200) DEFAULT NULL,
  `custom_text` text,
  `code1` text,
  `code2` text,
  `is_paypal` tinyint(4) NOT NULL DEFAULT '0',
  `is_sandbox` tinyint(4) NOT NULL DEFAULT '0',
  `paypal` text,
  `db` TEXT NULL DEFAULT NULL,
  `access` INT( 11 ) NOT NULL DEFAULT '0',
  `data_listing_confirmation` TINYINT(4) NOT NULL DEFAULT '1',  
  `data_listing` TINYINT(4) NOT NULL DEFAULT '1', 
  PRIMARY KEY (`jid`)
);


DROP TABLE IF EXISTS `#__m4j_sef`;
CREATE TABLE IF NOT EXISTS `#__m4j_sef` (
  `jid` int(11) NOT NULL DEFAULT '0',
  `cid` int(11) NOT NULL DEFAULT '0',
  `url` varchar(192) DEFAULT NULL,
  PRIMARY KEY (`jid`,`cid`)
);


DROP TABLE IF EXISTS `#__m4j_storage`;
CREATE TABLE IF NOT EXISTS `#__m4j_storage` (
  `stid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `jid` int(11) NOT NULL,
  `fid` text NOT NULL,
  `date` timestamp NOT NULL,
  `tmp_dir` varchar(120) DEFAULT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `user_ip` varchar(15) DEFAULT NULL,
  `parameters` text NULL DEFAULT NULL,
  PRIMARY KEY (`stid`),
  KEY `user_id` (`user_id`,`user_ip`)
);


DROP TABLE IF EXISTS `#__m4j_storage_items`;
CREATE TABLE IF NOT EXISTS `#__m4j_storage_items` (
  `stiid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `stid` int(10) unsigned NOT NULL,
  `eid` int(11) NOT NULL,
  `content` text NOT NULL,
  PRIMARY KEY (`stiid`),
  INDEX(`stid`,`eid`)
);

