// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// @license: Mad4Media Javascipt License - copyright Mad4Media - Fahrettin Kutyol - All rights reserved    ++
// (re-) publishing or forking for any purpose of commercial or non-commercial use is not allowed.		   ++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

var MoojWindow = function(){
	this.cover = _newElement2Body(
			"div",
			{
				"opacity": "0.7",
				"display": "none",
				"backgroundColor": "black",
				"left": "0",
				"top": "0",
				"position": "fixed",
				"width": "100%",
				"height": "100%",
				"zIndex": "1000"
			},
			"", 
			"mCover");
	
	this.container = _newElement2Body(
			"div",
			{
				"display": "none",
				"backgroundColor": "white",
				"position": "fixed",
				"width": "800px",
				"height": "600px",
				"outline": this.outline,
				"border" : ( dojo.isIE && dojo.isIE !=8 ) ? this.outline : "none",
				"zIndex": "1001"
			},
			"", 
			"mWindowContainer");
	
	this.closeButton = _newElement2Body(
			"div",
			{
				"display": "none",
				"position": "fixed",
				"width": "24px",
				"height": "24px",
				"zIndex": "1002"
			},
			"", 
			"mWindowCloseButton");
	this.closeButton.innerHTML = '<img src="components/com_proforms/images/close.png" width="24" height="24" border="0" style="cursor:pointer;" onclick="javascript: mWindow.close();" />';
	this.closeCallBack = this.emptyCall;	
}

MoojWindow.prototype = {
		width : 800,
		height: 600,
		outline : "10px solid black", 
		cover : undefined,
		container : undefined,
		closeButton : undefined,
		emptyCall: function(){return true;},
		closeCallBack: undefined,
		code: "",
		
		setOutline: function (outline){
			this.outline = outline;
			if(this.container){
				this.container.style.outline = outline;
			}
		},		
		
		setCode: function(code){
			this.code = code;
		},
		
		close: function(){
		dojo.fadeOut( {
			node : this.cover,
			duration: 500,
			onEnd : dojo.hitch(this,function(){
				this.cover.style.display = "none";
			})
		}).play();
	
		dojo.fadeOut( {
			node : this.container,
			duration: 500,
			onEnd : dojo.hitch(this,function(){
				this.container.style.display = "none";
				this.closeCallBack();
			})
		}).play();
		
		dojo.fadeOut( {
			node : this.closeButton,
			duration: 500,
			onEnd : dojo.hitch(this,function(){
				this.closeButton.style.display = "none";
			})
		}).play();
		
		},
		open: function(newSize){
			
			if(newSize){
				var windowSize =  _WindowSize();
				var maxWidth = windowSize.width -80;
				var maxHeight = windowSize.height -80;
				this.width = (newSize.width > maxWidth) ? maxWidth : newSize.width ; 
				this.height = (newSize.height > maxHeight) ? maxHeight : newSize.height ; 
				
			}
			
			this.container.style.width = this.width + "px";
			this.container.style.height = this.height + "px";
			var wH = Math.round(this.width/2);
			var hH = Math.round(this.height/2);
			
			var wCenter = _WindowCenter();	
			this.container.style.left = (wCenter.x-wH)+"px";
			this.container.style.top = (wCenter.y-hH)+"px";
			
			var cbSub = (dojo.isIE == 7) ? 0 : 12 ;
			this.closeButton.style.left = (wCenter.x+ wH - cbSub)+"px";
			this.closeButton.style.top = (wCenter.y- hH - cbSub)+"px";
			
			this.cover.style.display = "block";
			_fx.fadeOpacity(this.cover,500,0,0.7);
					
			dojo.fadeIn( {
				node : this.container,
				duration: 500,
				onPlay : dojo.hitch(this,function(){
					this.container.style.display = "block";
				})
			}).play();
			
			dojo.fadeIn( {
				node : this.closeButton,
				duration: 500,
				onPlay : dojo.hitch(this,function(){
					this.closeButton.style.display = "block";
				})
			}).play();
			
		},
		openAuto: function(){
			this.open({width:999999,height:999999});
		},
		
		iFrame: function(href,size,closeCallBack){
			this.closeCallBack = (closeCallBack) ? closeCallBack : this.emptyCall;
			
			this.container.innerHTML = '<iframe name="mWindowIFrame" id="mWindowIFrame" src="'+href+'" frameborder="0" scrolling="auto"></iframe>';
			if(size){
				this.open(size);
			}else{
				this.openAuto();
			}
			var ws = _S("mWindowIFrame");
			ws.width = "100%";
			ws.height = "100%";
		},
		content: function(size,closeCallBack){
			this.closeCallBack = (closeCallBack) ? closeCallBack : this.emptyCall;
			this.container.innerHTML = this.code;
			this.open(size);
			
		},
		
		load: function(href,size,closeCallBack){
			this.closeCallBack = (closeCallBack) ? closeCallBack : this.emptyCall;
			var lcb = dojo.hitch(this,function(response,ioArgs){
				this.container.innerHTML = response;
				this.open(size);
				return true;
			});
			
			var errBack = dojo.hitch(this,function(response,ioArgs){
				this.container.innerHTML = "ERROR";
				this.open(size);
				return false;
			});
			
			return dojo.xhrGet({
			    url: href,
			    load: lcb,
			    error: errBack
			});	
		}
		
		
}

var mWindow = undefined;

dojo.addOnLoad(function(){
		mWindow = new MoojWindow();
	
})