<?php
/**
 * @package Component BoWoB Chat for Joomla! 1.5
 * @version $Id: bowob_joomla.php 599 2010-06-12 19:22:00Z Jonatan Linares $
 * @author Jonatan Linares
 * @copyright (C) 2010- Jonatan Linares
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

if(file_exists(dirname(__FILE__) . DS . "bowob_core.php"))
  include(dirname(__FILE__) . DS . "bowob_core.php");

function bowobs_version()
{
  return '1_0';
}

function bowobs_user_logued()
{
  $user =& JFactory::getUser();
  
  return !($user->guest);
}

function bowobs_user_id()
{
  $user =& JFactory::getUser();
  
  return $user->id;
}

function bowobs_user_name()
{
  $user =& JFactory::getUser();

  if($user->guest)
    return '';
  else
    return $user->username;
}

function bowobs_user_validate($username)
{
  $db =& JFactory::getDBO();
  
  if(trim($username) == '')
    return 1;
  elseif(preg_match("#[<>\"'%;()&]#i", $username) || strlen(utf8_decode($username)) < 2)
    return 2;
  else
  {
    $db->setQuery('SELECT id FROM #__users WHERE username = ' . $db->quote($username));
    if(!($db->query()))
      return 3;
    if($db->getNumRows() > 0)
      return 3;
  }
  
  return 0;
}

function bowobs_user_logued_validate()
{
  return true;
}

function bowobs_redirect_index()
{
  $mainframe =& JFactory::getApplication('site');
  
  $mainframe->redirect(JURI::base());
  exit();
}

function bowobs_redirect_login()
{
  $mainframe =& JFactory::getApplication('site');
  
  $mainframe->redirect(JRoute::_('index.php?option=com_user&view=login'));
  exit();
}

function bowobs_enable(){}

function bowobs_disable(){}

function bowobs_db_insert($sync, $time, $user, $type)
{
  $db =& JFactory::getDBO();
  
  $db->setQuery('INSERT INTO #__bowob (sync, time, user, type) VALUES (' . $db->quote($sync) . ', ' . (int)$time . ', ' . $db->quote($user) . ', ' . (int)$type . ')'); 
  
  if(!$db->query())
    return 0;
  
  return $db->insertid();
}

function bowobs_db_extract($sid, $ssync, $stime)
{
  $db =& JFactory::getDBO();
  
  $db->setQuery('DELETE FROM #__bowob WHERE time < ' . (int)$stime);
  
  $db->setQuery('SELECT sync, user, type FROM #__bowob WHERE id = ' . (int)$sid . ' AND sync = ' . $db->quote($ssync)); 
  $res = $db->loadObject();
  
  if(!$res || $res->sync != $ssync)
  {
    return array();
  }
  else
  {
    $db->setQuery('DELETE FROM #__bowob WHERE id = ' . (int)$sid);
    return array($res->user, $res->type, '');
  }
}

function bowobs_form_blocklink()
{
  return '<ul><li><a href="' . JRoute::_('index.php?option=com_bowobchat') . '">' . JText::_('Chat') . '</a></li></ul>' . "\n";
}

function bowobs_form_blocklogin()
{
  $output = '';

  $output .= '<form id="form-login" name="mod_bowobchatlogin" method="post" action="' . JRoute::_('index.php?option=com_bowobchat&bowob_step=1') . '">' . "\n";
  $output .= '  <fieldset class="input">' . "\n";
  $output .= '    <p>' . "\n";
  $output .= '      <label for="mod_bowobchatlogin_username">Username</label><br>' . "\n";
  $output .= '      <input type="text" size="18" alt="username" class="inputbox" name="username" id="mod_bowobchatlogin_username">' . "\n";
  $output .= '    </p>' . "\n";
  $output .= '    <input type="submit" value="' . JText::_('Chat') . '" class="button" name="Submit">' . "\n";
  $output .= '  </fieldset>' . "\n";
  $output .= '</form>' . "\n";
  
  return $output;
}

function bowobs_form_login()
{
  $output = '';
  
  $output .= '<div class="componentheading">' . JText::_('Chat') . '</div>' . "\n";
  
  $output .= '<form id="com-form-login" name="com_bowobchat" action="' . JRoute::_('index.php?option=com_bowobchat&bowob_step=1') . '" method="post">' . "\n";
  
  $output .= '<fieldset class="input">' . "\n";
  $output .= '	<p id="com-form-login-username">' . "\n";
  $output .= '		<label for="username">' . JText::_('Username') . '</label><br />' . "\n";
  $output .= '		<input name="username" id="username" type="text" class="inputbox" alt="username" size="18" />' . "\n";
  $output .= '	</p>' . "\n";
  $output .= '	<input type="submit" name="Submit" class="button" value="' . JText::_('Chat') . '" />' . "\n";
  $output .= '</fieldset>' . "\n";
	
  $output .= '</form>' . "\n";

  return $output;
}

function bowobs_form_error($type, $username)
{
  $mainframe =& JFactory::getApplication('site');
  
  if($type == 1)
    $mainframe->redirect(JRoute::_('index.php?option=com_bowobchat'), JText::_('Please enter a user name.'), 'error');
  elseif($type == 2)
    $mainframe->redirect(JRoute::_('index.php?option=com_bowobchat'), JText::sprintf('VALID_AZ09', JText::_('Username'), 2), 'error');
  elseif($type == 3)
    $mainframe->redirect(JRoute::_('index.php?option=com_bowobchat'), JText::sprintf('WARNNAMETRYAGAIN', JText::_('Username')) . ' <a href="' . JRoute::_( 'index.php?option=com_user&view=login') . '">' . JText::_('LOGIN') . '</a>', 'error');
  
  exit();
}

function bowobs_cookie_get($value)
{
  return stripslashes($value);
}

?>
