<?php
/**
* @Copyright Copyright (C) 2010- Roger Noar, www.rayonics.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* Distributed under the terms of the GPL
**/

/**
 * Joomla! JRPassphrase
 * Version 1.55  , March 22, 2010
 * @author		Roger Noar
 * @package		Joomla 1.50
 * @subpackage	System
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class  plgSystemJRPassphrase extends JPlugin
{
	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @access	protected
	 * @param	object	$subject The object to observe
	 * @param 	array   $config  An array that holds the plugin configuration
	 * @since	1.0
	 */
	function plgSystemJRPassphrase(& $subject, $config)
	{
		parent::__construct($subject, $config);
	}

	function onAfterDispatch()  // Don't use onAfterInitialize - not reliable for redirection if SEF's are used
	{
		global $mainframe;
		$task	= JRequest::getCmd('task');
		$view	= JRequest::getCmd('view');
		if ( $task != 'register' && $view != 'register' ) { Return ;} //Exit if not a registration page - low overhead
		$jrpassphrase_version = 'JRPassphrase V1.55';	
		$pass 	= '';
		$pass	= JRequest::getCmd('pass');
		$option	= JRequest::getCmd('option');		


//  Get current URL
		$uri =& JFactory::getURI();
		$url = $uri->toString();
		$u_host = $uri->getHost();
		$u_path = $uri->getPath();		

//  Get parameters	
		$debug = $this->params->get('debug', '');		
		$reg_pass = $this->params->get('reg_passphrase', '');
		$reg_path = 'plugins/system/JRPassphrase_reg.php';
		//$reg_path = ('http://'. $u_host .  substr($u_path, 0, strpos($u_path, '/index.php') ) . '/plugins/system/JRPassphrase_reg.php');
		$alt_reg_url = $this->params->get('alt_reg_url', '');
		$passphrase_page_url = $this->params->get('passphrase_page_url', '');
		$fail_message = $this->params->get('fail_message', '');
		$intercept_message = $this->params->get('intercept_message', '');
		$bypass_string = $this->params->get('bypass_string', '');
		
		$reg_path = 'index.php' ; //reg path is front page by default			
		if ( !empty($passphrase_page_url) ) { $reg_path = $passphrase_page_url ;} //alternate location for passphrase page
		
//	Remove carriage returns	& spaces from the passphrase 
		$syms= array(" ","\r\n","\n\r","\r","\n","\l","\t",chr(13),chr(10)); //remove carriage returns & spaces
		$reg_pass= str_replace($syms, '', $reg_pass);
		$pass= str_replace($syms, '', $pass);
		$reg_pass=trim(strtolower($reg_pass)); //lower case only, remove leading & trailing spaces
		$pass=trim(strtolower($pass)); //lower case only, remove leading & trailing spaces

//  Display debug info
		if ($debug=='1') 
		{ 
		$mainframe->enqueueMessage( 'version=' . $jrpassphrase_version ) ;		
		$mainframe->enqueueMessage( 'pass=' . $pass ) ;				
		$mainframe->enqueueMessage( 'reg_pass=' . $reg_pass ) ;				
		$mainframe->enqueueMessage( 'alt_reg_url=' . $alt_reg_url ) ;			
		$mainframe->enqueueMessage( '$passphrase_page_url=' . $passphrase_page_url ) ;		
		$mainframe->enqueueMessage( '$reg_path ='. $reg_path ); 
		$mainframe->enqueueMessage( 'JFactory::getURI =' . $url ) ;		
		$mainframe->enqueueMessage( 'getHost =' . $u_host ) ;			
		$mainframe->enqueueMessage( 'getPath =' . $u_path ) ;			
		$mainframe->enqueueMessage( '$_SERVER[SERVER_NAME] =' . $_SERVER['SERVER_NAME'] ) ;			
		$mainframe->enqueueMessage( '$_SERVER[HTTP_HOST] =' . $_SERVER['HTTP_HOST'] ) ;	
		$mainframe->enqueueMessage( '$_SERVER[REQUEST_URI] =' . $_SERVER['REQUEST_URI'] ) ;  
		$mainframe->enqueueMessage( '$_SERVER[SCRIPT_NAME] =' . $_SERVER['SCRIPT_NAME'] ) ;
		}	

//  Bypass string checking
		if ( !empty($bypass_string) )    
		{
		$substring = explode(" ",$bypass_string); // get all bypass strings, separated by spaces
		$tag_match = false; // initialize as false		
			foreach($substring as $tag) 
			{
			if ( empty($tag) ) {break;} // stop if tag empty
			$tag_match = strpos($url, $tag);  //See if the substring tag is present in the path
			if ($tag_match !== false) {Return;} //If bypass string matches, then don't intercept
			}	
		}


//	Check passphrase 
		if( $pass != $reg_pass )
		{
			if ($pass=='' ) {$mainframe->enqueueMessage($intercept_message); }
			else {$mainframe->enqueueMessage($fail_message); }
			if ($debug=='1' ) {Return ;}
			$mainframe->redirect( $reg_path); //redirect since passphrase is incorrect
			Return;
		}	

//	Passphrase is correct at this point
		if ( !empty($alt_reg_url) && $debug=='0' ) //Check to see if we are using an alternate reg page
		{  
		$pos = strpos($url, $alt_reg_url);  //Check to see if already at the alternate reg page, to keep from looping redirection
		if ($pos === false) {$mainframe->redirect($alt_reg_url . '&pass=' . $reg_pass);} // redirect to alternate registration page
		}

	Return ;// return from function
	}

}
?>