<?php
/**
* @version		$Id: rokmoduleorder.php $
* @package		RocketTheme
* @copyright		Copyright (C) 2005 - 2009 RocketTheme. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.plugin.plugin' );

/**
 * Example System Plugin
 *
 * @author		Andy Miller  <andy@rockettheme.com>
 * @package		Joomla
 * @subpackage	none
 * @since 		1.5
 */
class plgSystemRokModuleOrder extends JPlugin {

	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @param object $subject The object to observe
	 * @since 1.5
	 */
	function plgSystemRokModuleOrder(& $subject, $params)
	{
		global $mainframe;
		
		//override message output
		$document =& JFactory::getDocument();
		
        if (version_compare(PHP_VERSION, '5.0.0', '<')) {
             JError::raiseError("500","RokModuleOrder System Plugin requires PHP 5 or greater, currently: PHP ".PHP_VERSION);
            return;
        }

		if (!$mainframe->isAdmin() and $document->getType() == 'html') {
			require_once JPATH_SITE.DS.'plugins'.DS.'system'.DS.'rokmoduleorder'.DS.'document.php';
			$document = new RTDocument($document);
			
			// Message override
			$type = 'message';
			$path = JPATH_SITE.DS.'plugins'.DS.'system'.DS.'rokmoduleorder'.DS.'message.php';
			$className = 'JDocumentRendererMessageRT';
			$document->addOverride($type, $path, $className);
			
			// Message override
			$type = 'modules';
			$path = JPATH_SITE.DS.'plugins'.DS.'system'.DS.'rokmoduleorder'.DS.'modules.php';
			$className = 'JDocumentRendererModulesRT';
			$document->addOverride($type, $path, $className);
		}
		
		parent::__construct( $subject, $params );
		
		// load plugin parameters
		$this->_plugin =& JPluginHelper::getPlugin('system', 'rokmoduleorder');
		$this->_params = new JParameter($this->_plugin->params);
	}
	
	function onAfterInitialise() {

	}

}