<?php
defined('JPATH_BASE') or die();

class JDocumentRendererModulesRT extends JDocumentRenderer
{
	/**
	 * Renders multiple modules script and returns the results as a string
	 *
	 * @access public
	 * @param string 	$name		The position of the modules to render
	 * @param array 	$params		Associative array of values
	 * @return string	The output of the script
	 */
	var $mycookie; 
	 
	function render( $position, $params = array(), $content = null )
	{
		$renderer =&  $this->_doc->loadRenderer('module');
		
		static $cookie;
		
		if (!isset($cookie)) {
		    $cookie = JRequest::getVar('affinity_modules', '', 'COOKIE', 'STRING');
		    $cookie = JDocumentRendererModulesRT::json_decode($cookie);
		}

        $this->mycookie = $cookie;
        $this->myposition = $position;

		$contents = '';
        $modules = JModuleHelper::getModules($position);
        
        //var_dump ($position);
        
        //reorder based on cookie here
        usort($modules,array(&$this,"cookieSort"));
        $modules = array_reverse($modules);
                
		foreach ($modules as $mod)  {
			$contents .= $renderer->render($mod, $params, $content);
		}
		return $contents;
	}
        
    function cookieSort($mod1, $mod2)
    {
        $cookie = $this->mycookie;
        $position = $this->myposition;
        
        if (isset($cookie->$position)) {
        
            $cookie_order = $cookie->$position;
            $pos1 = array_search ($mod1->id, $cookie_order);
            $pos2 = array_search ($mod2->id, $cookie_order);
        
            if ($pos1==$pos2)
                return 0;
            else
                return ($pos1 > $pos2 ? -1 : 1);
        } else {
            return 0;
        }
    }
    
    
	function json_encode($data) {
        if (!class_exists("Services_JSON")) {
        	include_once(JPATH_SITE.DS.'plugins'.DS.'system'.DS.'rokmoduleorder'.DS.'JSON.php');
        }
        if (!function_exists('json_encode')) {
	        $json = new Services_JSON();
	        return( $json->encode($data) );
	    } else {
	        return json_encode($data);
	    }
    }
	
	function json_decode($data, $output_mode=false) {
        if (!class_exists("Services_JSON")) {
            
        	include_once(JPATH_SITE.DS.'plugins'.DS.'system'.DS.'rokmoduleorder'.DS.'JSON.php');
        }
        if (!function_exists('json_decode')) {
            
        	$param = $output_mode ? 16:null;
			$json = new Services_JSON($param);
	        return( $json->decode($data) );    
        } else {
            return json_decode($data, $output_mode=false);
        }	    
	}
        
}