<?php
defined('JPATH_BASE') or die();

class Proxy
{
	protected $delegate;

	public function __construct($delegate) {
		$this->delegate = $delegate;
	}

	public function __call($method, $args) {
		if (method_exists($this, $method)) {
			//echo $method . ' - ' . sizeof($args);
				
			return call_user_func_array($method, $args);
		} else {
			return call_user_func_array(array($this->delegate, $method), $args);
		}
	}
	
	public function __get($key) {
		return $this->delegate->$key;
	}
	
	public function __set($key, $value) {
		return $this->delegate->$key = $value;
	}
}
